| Disk ARchive 2.7.19 Full featured and portable backup and archiving tool

Loading...
Searching...
No Matches
Public Member Functions | Protected Member Functions | Private Attributes | List of all members
libdar::scrambler Class Reference
Private

scrambler is a very weak encryption scheme More...

`#include <scrambler.hpp>`

Inherits libdar::generic_file.

## Public Member Functions
| scrambler (const secu_string &pass, generic_file &hidden_side)
| scrambler (const scrambler &ref)=delete
| scrambler (scrambler &&ref) noexcept=delete
scrambler & | operator= (const scrambler &ref)=delete
scrambler & | operator= (scrambler &&ref) noexcept=delete
virtual bool | skippable (skippability direction, const infinint &amount) override
| whether the implementation is able to skip
virtual bool | skip (const infinint &pos) override
| skip at the absolute position
virtual bool | skip_to_eof () override
| skip to the end of file
virtual bool | skip_relative (S_I x) override
| skip relatively to the current position
virtual bool | truncatable (const infinint &pos) const override
| whether the implementation is able to truncate to the given position
virtual infinint | get_position () const override
| get the current read/write position
Public Member Functions inherited from libdar::generic_file
| generic_file (gf_mode m)
| main constructor
| generic_file (const generic_file &ref)
| copy constructor
| generic_file (generic_file &&ref) noexcept
| move constructor
generic_file & | operator= (const generic_file &ref)
| assignment operator
generic_file & | operator= (generic_file &&ref) noexcept
| move operator
| ~generic_file () noexcept(false)
| virtual destructor,
void | terminate ()
| destructor-like call, except that it is allowed to throw exceptions
bool | operator== (generic_file &ref)
bool | operator!= (generic_file &ref)
gf_mode | get_mode () const
| retreive the openning mode for this object
void | read_ahead (const infinint &amount)
void | ignore_read_ahead (bool mode)
virtual U_I | read (char *a, U_I size) override
| read data from the generic_file inherited from proto_generic_file
virtual void | write (const char *a, U_I size) override
| write data to the generic_file inherited from proto_generic_file
void | write (const std::string &arg)
| write a string to the generic_file
S_I | read_back (char &a)
| skip back one char, read on char and skip back one char
S_I | read_forward (char &a)
| read one char
virtual void | truncate (const infinint &pos)
| truncate file at the given offset
virtual void | copy_to (generic_file &ref)
| copy all data from current position to the object in argument
virtual void | copy_to (generic_file &ref, const infinint &crc_size, crc *&value)
| copy all data from the current position to the object in argument and computes a CRC value of the transmitted data
U_32 | copy_to (generic_file &ref, U_32 size)
| small copy (up to 4GB) with CRC calculation
infinint | copy_to (generic_file &ref, infinint size)
| copy the given amount to the object in argument
bool | diff (generic_file &f, const infinint &me_read_ahead, const infinint &you_read_ahead, const infinint &crc_size, crc *&value)
| compares the contents with the object in argument
bool | diff (generic_file &f, const infinint &me_read_ahead, const infinint &you_read_ahead, const infinint &crc_size, crc *&value, infinint &err_offset)
void | reset_crc (const infinint &width)
| reset CRC on read or writen data
bool | crc_status () const
| to known whether CRC calculation is activated or not
crc * | get_crc ()
| get CRC of the transfered date since last reset
void | sync_write ()
| write any pending data
void | flush_read ()
| be ready to read at current position, reseting all pending data for reading, cached and in compression engine for example
Public Member Functions inherited from libdar::proto_generic_file
| proto_generic_file (const proto_generic_file &ref)=default
| copy constructor
| proto_generic_file (proto_generic_file &&ref) noexcept=default
| move constructor
proto_generic_file & | operator= (const proto_generic_file &ref)=default
| assignment operator
proto_generic_file & | operator= (proto_generic_file &&ref) noexcept=default
| move operator
virtual | ~proto_generic_file () noexcept(false)
| virtual destructor

## Protected Member Functions
virtual void | inherited_read_ahead (const infinint &amount) override
| tells the object that several calls to read() will follow to probably obtain at least the given amount of data
virtual U_I | inherited_read (char *a, U_I size) override
| implementation of read() operation
virtual void | inherited_write (const char *a, U_I size) override
| implementation of the write() operation
virtual void | inherited_truncate (const infinint &pos) override
| truncate file at the give offset
virtual void | inherited_sync_write () override
| write down any pending data
virtual void | inherited_flush_read () override
| reset internal engine, flush caches in order to read the data at current position
virtual void | inherited_terminate () override
| destructor-like call, except that it is allowed to throw exceptions
Protected Member Functions inherited from libdar::generic_file
void | set_mode (gf_mode x)
bool | is_terminated () const

## Private Attributes
secu_string | key
U_I | len
generic_file * | ref
unsigned char * | buffer
U_I | buf_size

## Additional Inherited Members
Public Types inherited from libdar::generic_file
enum | skippability { skip_backward , skip_forward }

## Detailed Description

scrambler is a very weak encryption scheme

Definition at line 45 of file scrambler.hpp.

## Constructor & Destructor Documentation

## ◆ ~scrambler()

libdar::scrambler::~scrambler | ( |  | ) |
| inline

Definition at line 53 of file scrambler.hpp.

## Member Function Documentation

## ◆ get_position()

virtual infinint libdar::scrambler::get_position | ( |  | ) | const
| inline override virtual

get the current read/write position

Implements libdar::generic_file.

Definition at line 61 of file scrambler.hpp.

References get_position().

Referenced by get_position().

## ◆ inherited_flush_read()

virtual void libdar::scrambler::inherited_flush_read | ( |  | ) |
| inline override protected virtual

reset internal engine, flush caches in order to read the data at current position

Note
  when the object relies on external object or system object to fetch the data from for reading, when a call to (inherited_)flush_read() occurs, the current object must not assume that any previously read data is still valid if it has internal buffers or the like and it should flush them asap. This call must not propagate the flush_read to any other gneric_file object it could rely on

Implements libdar::generic_file.

Definition at line 69 of file scrambler.hpp.

## ◆ inherited_read()

virtual U_I libdar::scrambler::inherited_read | ( | char * | a,
|  | U_I | size )
| override protected virtual

implementation of read() operation

Parameters

  [in,out] | a | where to put the data to read
  [in] | size | says how much data to read

Returns
  the exact amount of data read and put into 'a'

Note
  read as much byte as requested, up to end of file stays blocked if not enough data is available and EOF not yet met. May return less data than requested only if EOF as been reached. in other worlds, EOF is reached when returned data is stricly less than the requested data Any problem shall be reported by throwing an exception.

Implements libdar::generic_file.

## ◆ inherited_read_ahead()

virtual void libdar::scrambler::inherited_read_ahead | ( | const infinint & | amount | ) |
| inline override protected virtual

tells the object that several calls to read() will follow to probably obtain at least the given amount of data

Parameters

  [in] | amount | is the maximum expected amount of data that is known to be read

Note
  this call may be implemented as a do-nothing call, its presence is only to allow optimization when possible, like in multi-threaded environment

Implements libdar::generic_file.

Definition at line 64 of file scrambler.hpp.

References libdar::generic_file::read_ahead().

## ◆ inherited_sync_write()

virtual void libdar::scrambler::inherited_sync_write | ( |  | ) |
| inline override protected virtual

write down any pending data

Note
  called after sanity checks from generic_file::sync_write() this method's role is to write down any data pending for writing in the current object it has not to be propagated to other gneric_file object this object could rely on

Implements libdar::generic_file.

Definition at line 68 of file scrambler.hpp.

## ◆ inherited_terminate()

virtual void libdar::scrambler::inherited_terminate | ( |  | ) |
| inline override protected virtual

destructor-like call, except that it is allowed to throw exceptions

Note
  this method must never be called directly but using terminate() instead, generic_file class manages it to never be called more than once

Implements libdar::generic_file.

Definition at line 70 of file scrambler.hpp.

## ◆ inherited_truncate()

virtual void libdar::scrambler::inherited_truncate | ( | const infinint & | pos | ) |
| inline override protected virtual

truncate file at the give offset

Note
  if pos is greater than the current file size, this call may do nothing (not even enlarging the file)
  this call should always fail on a read-only generic_file
  implementation must throw exception if truncate is not possible for other reason than read/write access mode

Implements libdar::generic_file.

Definition at line 67 of file scrambler.hpp.

References libdar::generic_file::truncate().

## ◆ inherited_write()

virtual void libdar::scrambler::inherited_write | ( | const char * | a,
|  | U_I | size )
| override protected virtual

implementation of the write() operation

Parameters

  [in] | a | what data to write
  [in] | size | amount of data to write

Note
  must either write all data or report an error by throwing an exception

Implements libdar::generic_file.

## ◆ skip()

virtual bool libdar::scrambler::skip | ( | const infinint & | pos | ) |
| inline override virtual

skip at the absolute position

Parameters

  [in] | pos | the offset in byte where next read/write operation must start

Returns
  true if operation was successfull and false if the requested position is not valid (after end of file)

Note
  if requested position is not valid the reading/writing cursor must be set to the closest valid position

Implements libdar::generic_file.

Definition at line 57 of file scrambler.hpp.

References skip().

Referenced by skip().

## ◆ skip_relative()

virtual bool libdar::scrambler::skip_relative | ( | S_I | x | ) |
| inline override virtual

skip relatively to the current position

Implements libdar::generic_file.

Definition at line 59 of file scrambler.hpp.

References skip_relative().

Referenced by skip_relative().

## ◆ skip_to_eof()

virtual bool libdar::scrambler::skip_to_eof | ( |  | ) |
| inline override virtual

skip to the end of file

Implements libdar::generic_file.

Definition at line 58 of file scrambler.hpp.

References skip_to_eof().

Referenced by skip_to_eof().

## ◆ skippable()

virtual bool libdar::scrambler::skippable | ( | skippability | direction,
|  | const infinint & | amount )
| inline override virtual

whether the implementation is able to skip

Note
  the capability to skip does not mean that skip_relative() or skip() will succeed, but rather that the inherited class implementation does not by construction forbid the requested skip (like inherited class providing a generic_file interface of an anonymous pipe for example)

Implements libdar::generic_file.

Definition at line 56 of file scrambler.hpp.

References skippable().

Referenced by skippable().

## ◆ truncatable()

virtual bool libdar::scrambler::truncatable | ( | const infinint & | pos | ) | const
| inline override virtual

whether the implementation is able to truncate to the given position

Implements libdar::generic_file.

Definition at line 60 of file scrambler.hpp.

References truncatable().

Referenced by truncatable().

## Member Data Documentation

## ◆ buf_size

U_I libdar::scrambler::buf_size
| private

Definition at line 77 of file scrambler.hpp.

## ◆ buffer

unsigned char* libdar::scrambler::buffer
| private

Definition at line 76 of file scrambler.hpp.

## ◆ key

secu_string libdar::scrambler::key
| private

Definition at line 73 of file scrambler.hpp.

## ◆ len

U_I libdar::scrambler::len
| private

Definition at line 74 of file scrambler.hpp.

## ◆ ref

generic_file* libdar::scrambler::ref
| private

Definition at line 75 of file scrambler.hpp.

The documentation for this class was generated from the following file:

- scrambler.hpp